# encoding: utf-8

require 'erb'

class HtmlPrinter
  include ERB::Util # for the #h method
  def initialize(output)
    @output = output
  end

  def print_summary( was_dry_run, duration, example_count, failure_count, pending_count )
    # TODO - kill dry_run?
    # if was_dry_run
    #   totals = "This was a dry-run"
    # else
    #   totals =  "#{example_count} example#{'s' unless example_count == 1}, "
    #   totals << "#{failure_count} failure#{'s' unless failure_count == 1}"
    #   totals << ", #{pending_count} pending" if pending_count > 0
    # end
    # formatted_duration = sprintf("%.5f", duration)
    # @output.puts "<script>document.getElementById('duration').innerHTML = \"Finished in <strong>#{formatted_duration} seconds</strong>\";</script>"
    # @output.puts "<script>document.getElementById('totals').innerHTML = \"#{totals}\";</script>"
  end

  def print_table(table, table_header)
    @output.puts '<thead><tr><th>&nbsp;</th>'
    totals = {}
    table_header.keys.each do |name|
      @output.puts "<th>#{h(name)}</th>"
      totals[name] = 0
    end
    @output.puts "</tr></thead><tbody>"
    table.each do |name, examples|
      @output.puts "<tr><td>#{h(name)}</td>"
      examples.each do |name, value|
        value = if value == true
          totals[name] += 1
          "<td>+</td>"
        else
          value = value.gsub(/^[\r\n\s]+|[\r\n\s]+$/m, '')
            .gsub('expected: ', 'expected:')
            .gsub(/^\s+got: /, 'got:')
            .gsub('&nbsp;', '&amp;nbsp;')
            .gsub("\"(compared using ==)", "\"\n(compared using ==)")
          "<td title='#{value}'>-</td>"
        end
        @output.puts value
      end
      @output.puts "</tr>"
    end
    @output.puts "<tr><td>Итого (всего: #{table.keys.length}):</td>"
    totals.each do |name, total|
      @output.puts "<td>#{total}</td>"
    end
    @output.puts "</tr></tbody>"
  end

  def flush
    @output.flush
  end
end
